Index: trunk/Assembly_Library/Src/Display/DisplayFormatCompressed.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/DisplayFormatCompressed.asm	(revision 492)
+++ trunk/Assembly_Library/Src/Display/DisplayFormatCompressed.asm	(revision 505)
@@ -139,8 +139,7 @@
 
 .PrintDigit:
-	add		al, 90h						; Convert binary digit in AL to ASCII hex digit (0 - 9 or A - F)
-	daa
-	adc		al, 40h
-	daa
+	cmp		al, 10						; Convert binary digit in AL to ASCII hex digit ('0'-'9' or 'A'-'F')
+	sbb		al, 69h
+	das
 
 	call	DisplayPrint_CharacterFromAL
Index: trunk/Assembly_Library/Src/Display/DisplayPrint.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 492)
+++ trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 505)
@@ -306,5 +306,5 @@
 %endif
 
-%ifndef EXCLUDE				
+%ifndef EXCLUDE
 ;--------------------------------------------------------------------
 ; DisplayPrint_RepeatCharacterFromALwithCountInCX
@@ -397,5 +397,5 @@
 ;	Parameters:
 ;		AL:		Character to display
-;               Zero value is ignored (no characer is printed)
+;               Zero value is ignored (no character is printed)
 ;		DS:		BDA segment (zero)
 ;		ES:DI:	Ptr to cursor location in video RAM
@@ -407,5 +407,5 @@
 ALIGN DISPLAY_JUMP_ALIGN
 DisplayPrint_CharacterFromAL:
-	test	al,al
+	test	al, al
 	jz		DisplayPrint_Ret
 
Index: trunk/Assembly_Library/Src/Menu/CharOutLineSplitter.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/CharOutLineSplitter.asm	(revision 492)
+++ trunk/Assembly_Library/Src/Menu/CharOutLineSplitter.asm	(revision 505)
@@ -45,6 +45,5 @@
 	xchg	ax, dx			; AL = First text line column offset
 	mov		ah, dl			; AH = Last text line column offset
-	CALL_DISPLAY_LIBRARY SetCharacterOutputParameterFromAX
-	ret
+	JMP_DISPLAY_LIBRARY SetCharacterOutputParameterFromAX
 
 
Index: trunk/Assembly_Library/Src/Menu/Dialog/DialogFile.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/Dialog/DialogFile.asm	(revision 492)
+++ trunk/Assembly_Library/Src/Menu/Dialog/DialogFile.asm	(revision 505)
@@ -3,5 +3,5 @@
 
 ;
-; XTIDE Universal BIOS and Associated Tools 
+; XTIDE Universal BIOS and Associated Tools
 ; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
 ;
@@ -10,9 +10,9 @@
 ; the Free Software Foundation; either version 2 of the License, or
 ; (at your option) any later version.
-; 
+;
 ; This program is distributed in the hope that it will be useful,
 ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-; GNU General Public License for more details.		
+; GNU General Public License for more details.
 ; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 ;
@@ -197,6 +197,5 @@
 	call	.FindMatchingFilesAndPrintThemToOffScreenBuffer
 
-	CALL_DISPLAY_LIBRARY PopDisplayContext
-	ret
+	JMP_DISPLAY_LIBRARY PopDisplayContext
 
 ;--------------------------------------------------------------------
@@ -372,6 +371,5 @@
 ALIGN JUMP_ALIGN
 .FormatStringInCSSIandReturn:
-	CALL_DISPLAY_LIBRARY FormatNullTerminatedStringFromCSSI
-	ret
+	JMP_DISPLAY_LIBRARY FormatNullTerminatedStringFromCSSI
 
 
@@ -755,6 +753,5 @@
 	call	MenuText_PrepareToDrawInformationArea
 	mov		si, g_szLoadingPleaseWait
-	CALL_DISPLAY_LIBRARY PrintNullTerminatedStringFromCSSI
-	ret
+	JMP_DISPLAY_LIBRARY PrintNullTerminatedStringFromCSSI
 
 
Index: trunk/Assembly_Library/Src/Menu/Dialog/DialogProgress.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/Dialog/DialogProgress.asm	(revision 492)
+++ trunk/Assembly_Library/Src/Menu/Dialog/DialogProgress.asm	(revision 505)
@@ -216,9 +216,6 @@
 ALIGN JUMP_ALIGN
 .RepeatProgressCharacterCXtimesFromAL:
-	jcxz	.NothingToRepeat
-	CALL_DISPLAY_LIBRARY PrintRepeatedCharacterFromALwithCountInCX
-ALIGN JUMP_ALIGN, ret
-.NothingToRepeat:
-	ret
+	jcxz	NothingToRepeat
+	JMP_DISPLAY_LIBRARY PrintRepeatedCharacterFromALwithCountInCX
 
 
@@ -236,4 +233,5 @@
 	mov		bx, [si+PROGRESS_DIALOG_IO.wMaxProgressValue]
 	sub		bx, [si+PROGRESS_DIALOG_IO.wMinProgressValue]
+NothingToRepeat:
 	ret
 
Index: trunk/Assembly_Library/Src/Menu/Dialog/DialogWord.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/Dialog/DialogWord.asm	(revision 492)
+++ trunk/Assembly_Library/Src/Menu/Dialog/DialogWord.asm	(revision 505)
@@ -1,11 +1,7 @@
-; File name		:	DialogWord.asm
 ; Project name	:	Assembly Library
-; Created date	:	10.8.2010
-; Last update	:	18.11.2010
-; Author		:	Tomi Tilli
 ; Description	:	Displays word input dialog.
 
 ;
-; XTIDE Universal BIOS and Associated Tools 
+; XTIDE Universal BIOS and Associated Tools
 ; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
 ;
@@ -14,12 +10,12 @@
 ; the Free Software Foundation; either version 2 of the License, or
 ; (at your option) any later version.
-; 
+;
 ; This program is distributed in the hope that it will be useful,
 ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-; GNU General Public License for more details.		
+; GNU General Public License for more details.
 ; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 ;
-		
+
 
 ; Section containing code
@@ -142,4 +138,4 @@
 
 	xchg	ax, dx
-	CALL_DISPLAY_LIBRARY SetCursorCoordinatesFromAX
-	ret
+	JMP_DISPLAY_LIBRARY SetCursorCoordinatesFromAX
+
Index: trunk/Assembly_Library/Src/Menu/MenuAttributes.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuAttributes.asm	(revision 492)
+++ trunk/Assembly_Library/Src/Menu/MenuAttributes.asm	(revision 505)
@@ -4,5 +4,5 @@
 
 ;
-; XTIDE Universal BIOS and Associated Tools 
+; XTIDE Universal BIOS and Associated Tools
 ; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
 ;
@@ -11,12 +11,12 @@
 ; the Free Software Foundation; either version 2 of the License, or
 ; (at your option) any later version.
-; 
+;
 ; This program is distributed in the hope that it will be useful,
 ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-; GNU General Public License for more details.		
+; GNU General Public License for more details.
 ; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 ;
-		
+
 
 ; Struct containing border characters for different types of menu window lines
@@ -48,6 +48,5 @@
 MenuAttribute_SetToDisplayContextFromTypeInSI:
 	call	MenuAttribute_GetToAXfromTypeInSI
-	CALL_DISPLAY_LIBRARY SetCharacterAttributeFromAL
-	ret
+	JMP_DISPLAY_LIBRARY SetCharacterAttributeFromAL
 
 
Index: trunk/Assembly_Library/Src/Menu/MenuBorders.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuBorders.asm	(revision 492)
+++ trunk/Assembly_Library/Src/Menu/MenuBorders.asm	(revision 505)
@@ -3,5 +3,5 @@
 
 ;
-; XTIDE Universal BIOS and Associated Tools 
+; XTIDE Universal BIOS and Associated Tools
 ; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
 ;
@@ -10,12 +10,12 @@
 ; the Free Software Foundation; either version 2 of the License, or
 ; (at your option) any later version.
-; 
+;
 ; This program is distributed in the hope that it will be useful,
 ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-; GNU General Public License for more details.		
+; GNU General Public License for more details.
 ; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 ;
-		
+
 
 ; Struct containing border characters for different types of menu window lines
@@ -296,6 +296,5 @@
 ALIGN MENU_JUMP_ALIGN
 PrintNewlineToEndBorderLine:
-	CALL_DISPLAY_LIBRARY PrintNewlineCharacters
-	ret
+	JMP_DISPLAY_LIBRARY PrintNewlineCharacters
 
 
@@ -325,6 +324,5 @@
 	call	MenuBorders_PrintMultipleBorderCharactersFromAL	; AL does not matter
 
-	CALL_DISPLAY_LIBRARY PopDisplayContext
-	ret
+	JMP_DISPLAY_LIBRARY PopDisplayContext
 
 
@@ -365,6 +363,5 @@
 ALIGN MENU_JUMP_ALIGN
 MenuBorders_PrintSingleBorderCharacterFromAL:
-	CALL_DISPLAY_LIBRARY PrintCharacterFromAL
-	ret
+	JMP_DISPLAY_LIBRARY PrintCharacterFromAL
 
 ALIGN MENU_JUMP_ALIGN
Index: trunk/Assembly_Library/Src/Menu/MenuEvent.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuEvent.asm	(revision 492)
+++ trunk/Assembly_Library/Src/Menu/MenuEvent.asm	(revision 505)
@@ -3,5 +3,5 @@
 
 ;
-; XTIDE Universal BIOS and Associated Tools 
+; XTIDE Universal BIOS and Associated Tools
 ; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
 ;
@@ -10,12 +10,12 @@
 ; the Free Software Foundation; either version 2 of the License, or
 ; (at your option) any later version.
-; 
+;
 ; This program is distributed in the hope that it will be useful,
 ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-; GNU General Public License for more details.		
+; GNU General Public License for more details.
 ; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 ;
-		
+
 
 ; Section containing code
@@ -58,5 +58,5 @@
 	jmp		SHORT MenuEvent_SendFromBX
 %endif
-		
+
 
 %ifdef MENUEVENT_IDLEPROCESSING_ENABLE
@@ -155,5 +155,5 @@
 ;		AX, BX, DX
 ;--------------------------------------------------------------------
-%ifdef MENUEVENT_KeyStrokInAX
+%ifdef MENUEVENT_KeyStrokeInAX
 ALIGN MENU_JUMP_ALIGN
 MenuEvent_KeyStrokeInAX:
Index: trunk/Assembly_Library/Src/Menu/MenuText.asm
===================================================================
--- trunk/Assembly_Library/Src/Menu/MenuText.asm	(revision 492)
+++ trunk/Assembly_Library/Src/Menu/MenuText.asm	(revision 505)
@@ -3,5 +3,5 @@
 
 ;
-; XTIDE Universal BIOS and Associated Tools 
+; XTIDE Universal BIOS and Associated Tools
 ; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
 ;
@@ -10,12 +10,12 @@
 ; the Free Software Foundation; either version 2 of the License, or
 ; (at your option) any later version.
-; 
+;
 ; This program is distributed in the hope that it will be useful,
 ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-; GNU General Public License for more details.		
+; GNU General Public License for more details.
 ; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 ;
-		
+
 
 ; Section containing code
@@ -40,5 +40,5 @@
 	jmp		SHORT MenuText_ClearInformationArea.ClearCLlinesOfText
 %endif
-		
+
 ALIGN MENU_JUMP_ALIGN
 MenuText_ClearInformationArea:
@@ -53,6 +53,5 @@
 	mov		al, ' '
 	CALL_DISPLAY_LIBRARY PrintRepeatedCharacterFromALwithCountInCX
-	CALL_DISPLAY_LIBRARY PopDisplayContext
-	ret
+	JMP_DISPLAY_LIBRARY PopDisplayContext
 
 
@@ -220,6 +219,5 @@
 
 	xchg	ax, bx
-	CALL_DISPLAY_LIBRARY SetCursorCoordinatesFromAX
-	ret
+	JMP_DISPLAY_LIBRARY SetCursorCoordinatesFromAX
 
 
Index: trunk/Assembly_Library/Src/TimerTest.asm
===================================================================
--- trunk/Assembly_Library/Src/TimerTest.asm	(revision 492)
+++ trunk/Assembly_Library/Src/TimerTest.asm	(revision 505)
@@ -3,5 +3,5 @@
 
 ;
-; XTIDE Universal BIOS and Associated Tools 
+; XTIDE Universal BIOS and Associated Tools
 ; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
 ;
@@ -10,11 +10,11 @@
 ; the Free Software Foundation; either version 2 of the License, or
 ; (at your option) any later version.
-; 
+;
 ; This program is distributed in the hope that it will be useful,
 ; but WITHOUT ANY WARRANTY; without even the implied warranty of
 ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-; GNU General Public License for more details.		
+; GNU General Public License for more details.
 ; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
-;		
+;
 
 ; Include .inc files
@@ -109,5 +109,5 @@
 ;	Parameters:
 ;		AX:		Difference in register and memory access durations
-;				(Precise Event Timer Ticks)	
+;				(Precise Event Timer Ticks)
 ;	Returns:
 ;		AX:		Duration for single BYTE in nanosecs
@@ -182,6 +182,5 @@
 	push	dx
 	push	ax
-	CALL_DISPLAY_LIBRARY FormatNullTerminatedStringFromCSSI
-	ret
+	JMP_DISPLAY_LIBRARY FormatNullTerminatedStringFromCSSI
 
 